﻿Imports System.ComponentModel
Imports Telerik.WinControls
Imports Telerik.WinControls.UI

Public Class RadForm1
    Public Sub New()
        InitializeComponent()

    End Sub

    Private Sub radGridView1_RowSourceNeeded(sender As Object, e As GridViewRowSourceNeededEventArgs)
        If e.Template.HierarchyLevel = 1 Then
            Dim rowView As DataRowView = TryCast(e.ParentRow.DataBoundItem, DataRowView)
            Dim rows() As DataRow = rowView.Row.GetChildRows("CustomersOrders")

            For Each dataRow As DataRow In rows
                Dim row As GridViewRowInfo = e.Template.Rows.NewRow()
                row.Tag = dataRow
                row.Cells("OrderID").Value = dataRow("OrderID")
                row.Cells("CustomerID").Value = dataRow("CustomerID")
                row.Cells("OrderDate").Value = dataRow("OrderDate")
                e.SourceCollection.Add(row)
            Next dataRow
        Else
            Dim parentDataRow As DataRow = Nothing
            Dim rowView As DataRowView = TryCast(e.ParentRow.DataBoundItem, DataRowView)
            If rowView IsNot Nothing Then
                parentDataRow = rowView.Row
            Else
                parentDataRow = e.ParentRow.Tag
            End If

            Dim rows() As DataRow = parentDataRow.GetChildRows("OrdersOrder Details")
            For Each dataRow As DataRow In rows
                Dim row As GridViewRowInfo = e.Template.Rows.NewRow()
                row.Cells("OrderID").Value = dataRow("OrderID")
                row.Cells("ProductID").Value = dataRow("ProductID")
                row.Cells("Quantity").Value = dataRow("Quantity")

                e.SourceCollection.Add(row)
            Next dataRow
        End If

    End Sub

    Private Sub RadGridView1_Click(sender As Object, e As EventArgs) Handles RadGridView1.Click

    End Sub

    Private Sub RadForm1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Order_DetailsTableAdapter.Fill(Me.NwindDataSet.Order_Details)
        Me.OrdersTableAdapter.Fill(Me.NwindDataSet.Orders)
        Me.CustomersTableAdapter.Fill(Me.NwindDataSet.Customers)

        Me.RadGridView1.DataSource = CustomersBindingSource
        Me.RadGridView1.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill

        Dim firstChildTemplate As GridViewTemplate = Me.CreateFirstChildTemplate()
        Me.RadGridView1.Templates.Add(firstChildTemplate)
        firstChildTemplate.HierarchyDataProvider = New GridViewEventDataProvider(firstChildTemplate)

        Dim secondChildTemplate As GridViewTemplate = Me.CreateSecondChildTemplate()
        firstChildTemplate.Templates.Add(secondChildTemplate)
        secondChildTemplate.HierarchyDataProvider = New GridViewEventDataProvider(secondChildTemplate)
        AddHandler RadGridView1.RowSourceNeeded, AddressOf radGridView1_RowSourceNeeded

    End Sub

    Private Function CreateSecondChildTemplate() As GridViewTemplate
        Dim template As New GridViewTemplate()
        template.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill
        Dim idColumn As New GridViewDecimalColumn("OrderID")
        Dim productIdColumn As New GridViewDecimalColumn("ProductID")
        Dim quantityColumn As New GridViewTextBoxColumn("Quantity")
        template.Columns.AddRange(idColumn, productIdColumn, quantityColumn)

        Return template
    End Function

    Private Function CreateFirstChildTemplate() As GridViewTemplate
        Dim template As New GridViewTemplate()
        template.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill
        Dim idColumn As New GridViewDecimalColumn("OrderID")
        Dim customerIdColumn As New GridViewTextBoxColumn("CustomerID")
        Dim dateColumn As New GridViewDateTimeColumn("OrderDate")
        template.Columns.AddRange(idColumn, customerIdColumn, dateColumn)

        Return template
    End Function
End Class